program test
include 'mpif.h'
include 'cdagf.h'

integer a,b
integer ierr
integer graph
integer myrank
integer vertex
integer commsize
integer schedule
integer runhandle

call MPI_INIT(ierr)
call cDAGF_INIT(ierr)
call cDAGF_MY_RANK(myrank)
call cDAGF_GROUP_SIZE(commsize)

a = myrank;
b = -1;

call cDAGF_CREATE_GRAPH(graph)

call cDAGF_SEND(graph, a, 4, MOD((myrank+1),commsize), cDAG_USERSPACE, vertex)
call cDAGF_RECV(graph, b, 4, MOD((myrank-1+commsize),commsize), cDAG_USERSPACE, vertex)

call cDAGF_COMPILE(graph, schedule)
call cDAGF_FREE_GRAPH(graph)
call cDAGF_RUN(schedule, runhandle)
call cDAGF_WAIT(runhandle)

call cDAGF_FREE_SCHEDULE(schedule)

call cDAGF_FINALIZE(ierr)
call MPI_FINALIZE(ierr)
end program
