#include <mpi.h>
#include "tests.hpp"
#include "libcDAG.hpp"

int main(int argc, char** argv) {

	MPI_Init(&argc, &argv);
	TEST_INIT("sending integer in ring");

	cDAG_Init();

	int r = cDAG_MyRank();
	int p = cDAG_GroupSize();
	int a=r;
	int b=-1;

	cDAG_Graph g = cDAG_Create_graph();

	cDAG_Vertex send = cDAG_Send(g, &a, sizeof(int), (r+1)%p);
	cDAG_Vertex recv = cDAG_Recv(g, &b, sizeof(int), (r-1+p)%p);

	cDAG_Schedule sched = cDAG_Compile(g);
	cDAG_FreeGraph(g);
	cDAG_Handle hndl = cDAG_Run(sched);
	cDAG_Wait(hndl);

	cDAG_FreeSchedule(sched);

	if (b != (a-1+p)%p) TEST_FAILED();
	else TEST_SUCCESSFULL();

	cDAG_Finalize();
	MPI_Finalize();

}
