#include <mpi.h>
#include <string>

/*
TODO This could be made much cooler, for example we could
     check if the test is allready running longer than
     n seconds, if yes abort it and count it as failed
*/

static void TEST_INIT(std::string testname) {

	int myrank;

	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);

	if (myrank == 0) printf("%s ... ", testname.c_str());

}

static void TEST_FAILED() {

	int myrank;
	int size;

	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	
	int result = 1; // != 0 menas bad, unix-style
	int global_result = 1;
	MPI_Reduce(&result, &global_result, 1, MPI_INT, MPI_BOR, 0, MPI_COMM_WORLD);

	// global result is uninteresting here, since we know we failed 
	// at least at this rank, but we have to call the reduce anyway
	if (myrank == 0) printf("failed\n");

}

static void TEST_SUCCESSFULL() {

	int myrank;

	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);

	int result = 0; // == 0 menas bad, unix-style
	int global_result = 1;
	MPI_Reduce(&result, &global_result, 1, MPI_INT, MPI_BOR, 0, MPI_COMM_WORLD);

	if ((myrank == 0) && (global_result == 0)) printf("ok\n");
	if ((myrank == 0) && (global_result != 0)) printf("failed\n");

}

